classification
Title: MAP_SHARED isn't proper for anonymous mappings for VxWorks
Type: enhancement Stage: resolved
Components: Library (Lib) Versions: Python 3.8
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: lzhao, vstinner
Priority: normal Keywords: patch

Created on 2019-04-17 15:53 by lzhao, last changed 2019-05-21 11:59 by vstinner. This issue is now closed.

Pull Requests
URL Status Linked Edit
PR 12394 merged lzhao, 2019-04-17 15:53
Messages (5)
msg340411 - (view) Author: LihuaZhao (lzhao) * Date: 2019-04-17 15:53
anonymous mappings is not part of the POSIX standard, python user just need to specified -1 as fd value when do anonymous map, for example:

m = mmap.mmap(-1, 100)

then python adapter module(mmapmodule.c) try to specify MAP_SHARED or MAP_PRIVATE based on operate system requirement, Linux require MAP_SHARED, VxWorks require MAP_PRIVATE, this different should be hidden by this module, and python user won't be affected.

Currently, mmap is only adapted for the system which use MAP_SHARED when do anonymous map, VxWorks need be supported.

https://en.wikipedia.org/wiki/Mmap
msg340475 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2019-04-18 09:24
What is the current behavior of m = mmap.mmap(-1, 100)? Does it raise an exception?
msg340476 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2019-04-18 09:27
I don't understand why PR 12394 modifies flags afterwards, whereas "m = mmap.mmap(-1, 100)" doesn't specify explicitly flags. So the bug looks to be default flags set by Python, no?

    int flags = MAP_SHARED;
    ...

    if (!PyArg_ParseTupleAndKeywords(args, kwdict, "in|iii" _Py_PARSE_OFF_T, keywords,
                                     &fd, &map_size, &flags, &prot,
                                     &access, &offset))

Is MAP_SHARED constant available in C on VxWorks?

Is mmap.MAP_SHARED constant available in Python on VxWorks?
msg340481 - (view) Author: LihuaZhao (lzhao) * Date: 2019-04-18 10:10
>>What is the current behavior of m = mmap.mmap(-1, 100)? Does it raise an exception?

No, the following statement will return -1 without PR 12394

    m_obj->data = mmap(NULL, map_size,
                       prot, flags,
                       fd, offset);

>>I don't understand why PR 12394 modifies flags afterwards, whereas "m = mmap.mmap(-1, 100)" doesn't specify explicitly flags. So the bug looks to be default flags set by Python, no?

Yes, this statement doesn't specify the flag, but as you said, the new_mmap_object() firstly set MAP_SHARED for flag, and in later code:

    if (fd == -1) {
        m_obj->fd = -1;
    .....
#ifdef MAP_ANONYMOUS
        /* BSD way to map anonymous memory */
        flags |= MAP_ANONYMOUS;

#else
#endif

This routine will pass (MAP_ANONYMOUS | MAP_SHARED) to mmap and fd is -1, this is true for Linux, but for VxWorks, if fd is -1, the flag type should be (MAP_ANONYMOUS | MAP_PRIVATE), and this behavior is not part of the POSIX standard, we can't say VxWorks isn't right.

So my changes clear MAP_SHARED and set MAP_PRIVATE when the system type is VxWorks.

>>Is MAP_SHARED constant available in C on VxWorks?

Yes, but for MAP_ANONYMOUS, it require set MAP_PRIVATE.

This PR still is try to enhance VxWorks support, doesn't affect Python user, and only change the behavior of VxWorks, other system don't have this issue, and also won't be influenced
msg343007 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2019-05-21 10:50
New changeset 4fb15021890d327023aefd95f5a84ac33b037d19 by Victor Stinner (Lihua Zhao) in branch 'master':
bpo-36648: fix mmap issue for VxWorks (GH-12394)
https://github.com/python/cpython/commit/4fb15021890d327023aefd95f5a84ac33b037d19
History
Date User Action Args
2019-05-21 11:59:28vstinnersetstatus: open -> closed
resolution: fixed
stage: patch review -> resolved
2019-05-21 10:50:17vstinnersetmessages: + msg343007
2019-04-18 10:10:19lzhaosetmessages: + msg340481
2019-04-18 09:27:04vstinnersetmessages: + msg340476
2019-04-18 09:24:13vstinnersetmessages: + msg340475
2019-04-17 23:52:39lzhaosetpull_requests: - pull_request12788
2019-04-17 15:56:39lzhaosetkeywords: + patch
stage: patch review
pull_requests: + pull_request12788
2019-04-17 15:55:52lzhaosettype: enhancement
2019-04-17 15:54:55lzhaosetnosy: + vstinner
2019-04-17 15:53:41lzhaocreate